--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/main.inc.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/main.inc.php	2025-06-13 08:13:25.133163000 +0000
@@ -3684,7 +3695,7 @@
 			}
 
 			print '<div id="blockvmenuhelpbugreport" class="blockvmenuhelp">';
-			print '<a class="help" target="_blank" rel="noopener noreferrer" href="'.$bugbaseurl.'"><i class="fas fa-bug"></i> '.$langs->trans("FindBug").'</a>';
+			print '<a class="help" target="_blank" rel="noopener noreferrer" href="' . $bugbaseurl . '"><i class="fas fa-bug"></i> ' . $langs->trans("FindBug") . '</a>';
 			print '</div>';
 		}
 
@@ -3705,7 +3716,7 @@
 	}
 
 	print "\n";
-	print '<!-- Begin right area -->'."\n";
+	print '<!-- Begin right area -->' . "\n";
 
 	if (empty($leftmenuwithoutmainarea)) {
 		main_area($title);
@@ -3729,7 +3740,7 @@
 
 	print "\n";
 
-	print '<!-- Begin div class="fiche" -->'."\n".'<div class="fiche">'."\n";
+	print '<!-- Begin div class="fiche" -->' . "\n" . '<div class="fiche">' . "\n";
 
 	$hookmanager->initHooks(array('main'));
 	$parameters = array();
@@ -3745,30 +3756,30 @@
 		$parameters = array();
 		$reshook = $hookmanager->executeHooks('showSocinfoOnPrint', $parameters);
 		if (empty($reshook)) {
-			print '<!-- Begin show mysoc info header -->'."\n";
-			print '<div id="mysoc-info-header">'."\n";
-			print '<table class="centpercent div-table-responsive">'."\n";
+			print '<!-- Begin show mysoc info header -->' . "\n";
+			print '<div id="mysoc-info-header">' . "\n";
+			print '<table class="centpercent div-table-responsive">' . "\n";
 			print '<tbody>';
 			print '<tr><td rowspan="0" class="width20p">';
 			if (getDolGlobalString('MAIN_SHOW_LOGO') && !getDolGlobalString('MAIN_OPTIMIZEFORTEXTBROWSER') && getDolGlobalString('MAIN_INFO_SOCIETE_LOGO')) {
-				print '<img id="mysoc-info-header-logo" style="max-width:100%" alt="" src="'.DOL_URL_ROOT.'/viewimage.php?cache=1&modulepart=mycompany&file='.urlencode('logos/'.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_LOGO'))).'">';
+				print '<img id="mysoc-info-header-logo" style="max-width:100%" alt="" src="' . DOL_URL_ROOT . '/viewimage.php?cache=1&modulepart=mycompany&file=' . urlencode('logos/' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_LOGO'))) . '">';
 			}
-			print '</td><td  rowspan="0" class="width50p"></td></tr>'."\n";
-			print '<tr><td class="titre bold">'.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_NOM')).'</td></tr>'."\n";
-			print '<tr><td>'.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_ADDRESS')).'<br>'.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_ZIP')).' '.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_TOWN')).'</td></tr>'."\n";
+			print '</td><td  rowspan="0" class="width50p"></td></tr>' . "\n";
+			print '<tr><td class="titre bold">' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_NOM')) . '</td></tr>' . "\n";
+			print '<tr><td>' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_ADDRESS')) . '<br>' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_ZIP')) . ' ' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_TOWN')) . '</td></tr>' . "\n";
 			if (getDolGlobalString('MAIN_INFO_SOCIETE_TEL')) {
-				print '<tr><td style="padding-left: 1em" class="small">'.$langs->trans("Phone").' : '.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_TEL')).'</td></tr>';
+				print '<tr><td style="padding-left: 1em" class="small">' . $langs->trans("Phone") . ' : ' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_TEL')) . '</td></tr>';
 			}
 			if (getDolGlobalString('MAIN_INFO_SOCIETE_MAIL')) {
-				print '<tr><td style="padding-left: 1em" class="small">'.$langs->trans("Email").' : '.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_MAIL')).'</td></tr>';
+				print '<tr><td style="padding-left: 1em" class="small">' . $langs->trans("Email") . ' : ' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_MAIL')) . '</td></tr>';
 			}
 			if (getDolGlobalString('MAIN_INFO_SOCIETE_WEB')) {
-				print '<tr><td style="padding-left: 1em" class="small">'.$langs->trans("Web").' : '.dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_WEB')).'</td></tr>';
+				print '<tr><td style="padding-left: 1em" class="small">' . $langs->trans("Web") . ' : ' . dol_escape_htmltag(getDolGlobalString('MAIN_INFO_SOCIETE_WEB')) . '</td></tr>';
 			}
 			print '</tbody>';
-			print '</table>'."\n";
-			print '</div>'."\n";
-			print '<!-- End show mysoc info header -->'."\n";
+			print '</table>' . "\n";
+			print '</div>' . "\n";
+			print '<!-- End show mysoc info header -->' . "\n";
 		}
 	}
 }
@@ -3846,20 +3857,20 @@
 	global $langs, $user;
 
 	$ret = '';
-	$ret .= '<form action="'.$urlaction.'" method="post" class="searchform nowraponall tagtr">';
-	$ret .= '<input type="hidden" name="token" value="'.newToken().'">';
-	$ret .= '<input type="hidden" name="savelogin" value="'.dol_escape_htmltag($user->login).'">';
+	$ret .= '<form action="' . $urlaction . '" method="post" class="searchform nowraponall tagtr">';
+	$ret .= '<input type="hidden" name="token" value="' . newToken() . '">';
+	$ret .= '<input type="hidden" name="savelogin" value="' . dol_escape_htmltag($user->login) . '">';
 	if ($showtitlebefore) {
-		$ret .= '<div class="tagtd left">'.$title.'</div> ';
+		$ret .= '<div class="tagtd left">' . $title . '</div> ';
 	}
 	$ret .= '<div class="tagtd">';
 	$ret .= img_picto('', $img, '', 0, 0, 0, '', 'paddingright width20');
-	$ret .= '<input type="text" class="flat '.$htmlmorecss.'"';
+	$ret .= '<input type="text" class="flat ' . $htmlmorecss . '"';
 	$ret .= ' style="background-repeat: no-repeat; background-position: 3px;"';
-	$ret .= ($accesskey ? ' accesskey="'.$accesskey.'"' : '');
-	$ret .= ' placeholder="'.strip_tags($title).'"';
+	$ret .= ($accesskey ? ' accesskey="' . $accesskey . '"' : '');
+	$ret .= ' placeholder="' . strip_tags($title) . '"';
 	$ret .= ($autofocus ? ' autofocus' : '');
-	$ret .= ' name="'.$htmlinputname.'" id="'.$prefhtmlinputname.$htmlinputname.'" />';
+	$ret .= ' name="' . $htmlinputname . '" id="' . $prefhtmlinputname . $htmlinputname . '" />';
 	$ret .= '<button type="submit" class="button bordertransp" style="padding-top: 4px; padding-bottom: 4px; padding-left: 6px; padding-right: 6px">';
 	$ret .= '<span class="fa fa-search"></span>';
 	$ret .= '</button>';
@@ -3888,7 +3899,7 @@
 		global $contextpage, $page, $limit, $mode;
 		global $dolibarr_distrib;
 
-		$ext = 'layout='.urlencode($conf->browser->layout).'&version='.urlencode(DOL_VERSION);
+		$ext = 'layout=' . urlencode($conf->browser->layout) . '&version=' . urlencode(DOL_VERSION);
 
 		// Hook to add more things on all pages within fiche DIV
 		$llxfooter = '';
@@ -3911,7 +3922,7 @@
 		if (is_object($user) && !empty($user->lastsearch_values_tmp) && is_array($user->lastsearch_values_tmp)) {
 			// Clean and save data
 			foreach ($user->lastsearch_values_tmp as $key => $val) {
-				unset($_SESSION['lastsearch_values_tmp_'.$key]); // Clean array to rebuild it just after
+				unset($_SESSION['lastsearch_values_tmp_' . $key]); // Clean array to rebuild it just after
 				if (count($val) && empty($_POST['button_removefilter']) && empty($_POST['button_removefilter_x'])) {
 					if (empty($val['sortfield'])) {
 						unset($val['sortfield']);
@@ -3919,9 +3930,9 @@
 					if (empty($val['sortorder'])) {
 						unset($val['sortorder']);
 					}
-					dol_syslog('Save lastsearch_values_tmp_'.$key.'='.json_encode($val, 0)." (systematic recording of last search criteria)");
-					$_SESSION['lastsearch_values_tmp_'.$key] = json_encode($val);
-					unset($_SESSION['lastsearch_values_'.$key]);
+					dol_syslog('Save lastsearch_values_tmp_' . $key . '=' . json_encode($val, 0) . " (systematic recording of last search criteria)");
+					$_SESSION['lastsearch_values_tmp_' . $key] = json_encode($val);
+					unset($_SESSION['lastsearch_values_' . $key]);
 				}
 			}
 		}
@@ -3930,45 +3941,45 @@
 		$relativepathstring = $_SERVER["PHP_SELF"];
 		// Clean $relativepathstring
 		if (constant('DOL_URL_ROOT')) {
-			$relativepathstring = preg_replace('/^'.preg_quote(constant('DOL_URL_ROOT'), '/').'/', '', $relativepathstring);
+			$relativepathstring = preg_replace('/^' . preg_quote(constant('DOL_URL_ROOT'), '/') . '/', '', $relativepathstring);
 		}
 		$relativepathstring = preg_replace('/^\//', '', $relativepathstring);
 		$relativepathstring = preg_replace('/^custom\//', '', $relativepathstring);
 		if (preg_match('/list\.php$/', $relativepathstring)) {
-			unset($_SESSION['lastsearch_contextpage_tmp_'.$relativepathstring]);
-			unset($_SESSION['lastsearch_page_tmp_'.$relativepathstring]);
-			unset($_SESSION['lastsearch_limit_tmp_'.$relativepathstring]);
-			unset($_SESSION['lastsearch_mode_tmp_'.$relativepathstring]);
+			unset($_SESSION['lastsearch_contextpage_tmp_' . $relativepathstring]);
+			unset($_SESSION['lastsearch_page_tmp_' . $relativepathstring]);
+			unset($_SESSION['lastsearch_limit_tmp_' . $relativepathstring]);
+			unset($_SESSION['lastsearch_mode_tmp_' . $relativepathstring]);
 
 			if (!empty($contextpage)) {
-				$_SESSION['lastsearch_contextpage_tmp_'.$relativepathstring] = $contextpage;
+				$_SESSION['lastsearch_contextpage_tmp_' . $relativepathstring] = $contextpage;
 			}
 			if (!empty($page) && $page > 0) {
-				$_SESSION['lastsearch_page_tmp_'.$relativepathstring] = $page;
+				$_SESSION['lastsearch_page_tmp_' . $relativepathstring] = $page;
 			}
 			if (!empty($limit) && $limit != $conf->liste_limit) {
-				$_SESSION['lastsearch_limit_tmp_'.$relativepathstring] = $limit;
+				$_SESSION['lastsearch_limit_tmp_' . $relativepathstring] = $limit;
 			}
 			if (!empty($mode)) {
-				$_SESSION['lastsearch_mode_tmp_'.$relativepathstring] = $mode;
+				$_SESSION['lastsearch_mode_tmp_' . $relativepathstring] = $mode;
 			}
 
-			unset($_SESSION['lastsearch_contextpage_'.$relativepathstring]);
-			unset($_SESSION['lastsearch_page_'.$relativepathstring]);
-			unset($_SESSION['lastsearch_limit_'.$relativepathstring]);
-			unset($_SESSION['lastsearch_mode_'.$relativepathstring]);
+			unset($_SESSION['lastsearch_contextpage_' . $relativepathstring]);
+			unset($_SESSION['lastsearch_page_' . $relativepathstring]);
+			unset($_SESSION['lastsearch_limit_' . $relativepathstring]);
+			unset($_SESSION['lastsearch_mode_' . $relativepathstring]);
 		}
 
 		// Core error message
 		if (getDolGlobalString('MAIN_CORE_ERROR')) {
 			// Ajax version
 			if ($conf->use_javascript_ajax) {
-				$title = img_warning().' '.$langs->trans('CoreErrorTitle');
+				$title = img_warning() . ' ' . $langs->trans('CoreErrorTitle');
 				print ajax_dialog($title, $langs->trans('CoreErrorMessage'));
 			} else {
 				// html version
-				$msg = img_warning().' '.$langs->trans('CoreErrorMessage');
-				print '<div class="error">'.$msg.'</div>';
+				$msg = img_warning() . ' ' . $langs->trans('CoreErrorMessage');
+				print '<div class="error">' . $msg . '</div>';
 			}
 
 			//define("MAIN_CORE_ERROR",0);      // Constant was defined and we can't change value of a constant
@@ -3976,19 +3987,19 @@
 
 		print "\n\n";
 
-		print '</div> <!-- End div class="fiche" -->'."\n"; // End div fiche
+		print '</div> <!-- End div class="fiche" -->' . "\n"; // End div fiche
 
 		if (empty($conf->dol_hide_leftmenu) && !GETPOST('dol_openinpopup', 'aZ09')) {
-			print '</div> <!-- End div id-right -->'."\n"; // End div id-right
+			print '</div> <!-- End div id-right -->' . "\n"; // End div id-right
 		}
 
 		if (empty($conf->dol_hide_leftmenu) && empty($conf->dol_use_jmobile)) {
-			print '</div> <!-- End div id-container -->'."\n"; // End div container
+			print '</div> <!-- End div id-container -->' . "\n"; // End div container
 		}
 
 		print "\n";
 		if ($comment) {
-			print '<!-- '.$comment.' -->'."\n";
+			print '<!-- ' . $comment . ' -->' . "\n";
 		}
 
 		printCommonFooter($zone);
@@ -3998,40 +4009,36 @@
 		}
 
 		if (!empty($conf->use_javascript_ajax)) {
-			print "\n".'<!-- Includes JS Footer of Dolibarr -->'."\n";
-			print '<script src="'.DOL_URL_ROOT.'/core/js/lib_foot.js.php?lang='.$langs->defaultlang.($ext ? '&'.$ext : '').'"></script>'."\n";
+			print "\n" . '<!-- Includes JS Footer of Dolibarr -->' . "\n";
+			print '<script src="' . DOL_URL_ROOT . '/core/js/lib_foot.js.php?lang=' . $langs->defaultlang . ($ext ? '&' . $ext : '') . '"></script>' . "\n";
 		}
 
 		// JS wrapper to add log when clicking on download or preview
 		if (isModEnabled('blockedlog') && is_object($object) && !empty($object->id) && $object->id > 0) {
 			if (in_array($object->element, array('facture')) && $object->statut > 0) {       // Restrict for the moment to element 'facture'
 				print "\n<!-- JS CODE TO ENABLE log when making a download or a preview of a document -->\n";
-				?>
+?>
 				<script>
-				jQuery(document).ready(function () {
-					$('a.documentpreview').click(function() {
-						console.log("Call /blockedlog/ajax/block-add on a.documentpreview");
-						$.post('<?php echo DOL_URL_ROOT."/blockedlog/ajax/block-add.php" ?>'
-								, {
-									id:<?php echo $object->id; ?>
-									, element:'<?php echo dol_escape_js($object->element) ?>'
-									, action:'DOC_PREVIEW'
-									, token: '<?php echo currentToken(); ?>'
-								}
-						);
-					});
-					$('a.documentdownload').click(function() {
-						console.log("Call /blockedlog/ajax/block-add a.documentdownload");
-						$.post('<?php echo DOL_URL_ROOT."/blockedlog/ajax/block-add.php" ?>'
-								, {
-									id:<?php echo $object->id; ?>
-									, element:'<?php echo dol_escape_js($object->element) ?>'
-									, action:'DOC_DOWNLOAD'
-									, token: '<?php echo currentToken(); ?>'
-								}
-						);
+					jQuery(document).ready(function() {
+						$('a.documentpreview').click(function() {
+							console.log("Call /blockedlog/ajax/block-add on a.documentpreview");
+							$.post('<?php echo DOL_URL_ROOT . "/blockedlog/ajax/block-add.php" ?>', {
+								id: <?php echo $object->id; ?>,
+								element: '<?php echo dol_escape_js($object->element) ?>',
+								action: 'DOC_PREVIEW',
+								token: '<?php echo currentToken(); ?>'
+							});
+						});
+						$('a.documentdownload').click(function() {
+							console.log("Call /blockedlog/ajax/block-add a.documentdownload");
+							$.post('<?php echo DOL_URL_ROOT . "/blockedlog/ajax/block-add.php" ?>', {
+								id: <?php echo $object->id; ?>,
+								element: '<?php echo dol_escape_js($object->element) ?>',
+								action: 'DOC_DOWNLOAD',
+								token: '<?php echo currentToken(); ?>'
+							});
+						});
 					});
-				});
 				</script>
 				<?php
 			}
@@ -4039,30 +4046,32 @@
 
 		// A div for the #dialogforpopup popup
 		print "\n<!-- A div to allow dialog popup by jQuery('#dialogforpopup').dialog() -->\n";
-		print '<div id="dialogforpopup" style="display: none;"></div>'."\n";
+		print '<div id="dialogforpopup" style="display: none;"></div>' . "\n";
 
 		// Add code for the asynchronous anonymous first ping (for telemetry)
 		// You can use &forceping=1 in parameters to force the ping if the ping was already sent.
 		$forceping = GETPOST('forceping', 'alpha');
-		if (($_SERVER["PHP_SELF"] == DOL_URL_ROOT.'/index.php') || $forceping) {
+		if (($_SERVER["PHP_SELF"] == DOL_URL_ROOT . '/index.php') || $forceping) {
 			//print '<!-- instance_unique_id='.$conf->file->instance_unique_id.' MAIN_FIRST_PING_OK_ID='.$conf->global->MAIN_FIRST_PING_OK_ID.' -->';
-			$hash_unique_id = dol_hash('dolibarr'.$conf->file->instance_unique_id, 'sha256');	// Note: if the global salt changes, this hash changes too so ping may be counted twice. We don't mind. It is for statistics purpose only.
+			$hash_unique_id = dol_hash('dolibarr' . $conf->file->instance_unique_id, 'sha256');	// Note: if the global salt changes, this hash changes too so ping may be counted twice. We don't mind. It is for statistics purpose only.
 
-			if (!getDolGlobalString('MAIN_FIRST_PING_OK_DATE')
+			if (
+				!getDolGlobalString('MAIN_FIRST_PING_OK_DATE')
 				|| (!empty($conf->file->instance_unique_id) && ($hash_unique_id != $conf->global->MAIN_FIRST_PING_OK_ID) && (getDolGlobalString('MAIN_FIRST_PING_OK_ID') != 'disabled'))
-			|| $forceping) {
+				|| $forceping
+			) {
 				// No ping done if we are into an alpha version
 				if (strpos('alpha', DOL_VERSION) > 0 && !$forceping) {
 					print "\n<!-- NO JS CODE TO ENABLE the anonymous Ping. It is an alpha version -->\n";
-				} elseif (empty($_COOKIE['DOLINSTALLNOPING_'.$hash_unique_id]) || $forceping) {	// Cookie is set when we uncheck the checkbox in the installation wizard.
+				} elseif (empty($_COOKIE['DOLINSTALLNOPING_' . $hash_unique_id]) || $forceping) {	// Cookie is set when we uncheck the checkbox in the installation wizard.
 					// MAIN_LAST_PING_KO_DATE
 					// Disable ping if MAIN_LAST_PING_KO_DATE is set and is recent (this month)
 					if (getDolGlobalString('MAIN_LAST_PING_KO_DATE') && substr($conf->global->MAIN_LAST_PING_KO_DATE, 0, 6) == dol_print_date(dol_now(), '%Y%m') && !$forceping) {
 						print "\n<!-- NO JS CODE TO ENABLE the anonymous Ping. An error already occurred this month, we will try later. -->\n";
 					} else {
-						include_once DOL_DOCUMENT_ROOT.'/core/lib/functions2.lib.php';
+						include_once DOL_DOCUMENT_ROOT . '/core/lib/functions2.lib.php';
 
-						print "\n".'<!-- Includes JS for Ping of Dolibarr forceping='.$forceping.' MAIN_FIRST_PING_OK_DATE='.getDolGlobalString("MAIN_FIRST_PING_OK_DATE").' MAIN_FIRST_PING_OK_ID='.getDolGlobalString("MAIN_FIRST_PING_OK_ID").' MAIN_LAST_PING_KO_DATE='.getDolGlobalString("MAIN_LAST_PING_KO_DATE").' -->'."\n";
+						print "\n" . '<!-- Includes JS for Ping of Dolibarr forceping=' . $forceping . ' MAIN_FIRST_PING_OK_DATE=' . getDolGlobalString("MAIN_FIRST_PING_OK_DATE") . ' MAIN_FIRST_PING_OK_ID=' . getDolGlobalString("MAIN_FIRST_PING_OK_ID") . ' MAIN_LAST_PING_KO_DATE=' . getDolGlobalString("MAIN_LAST_PING_KO_DATE") . ' -->' . "\n";
 						print "\n<!-- JS CODE TO ENABLE the anonymous Ping -->\n";
 						$url_for_ping = getDolGlobalString('MAIN_URL_FOR_PING', "https://ping.dolibarr.org/");
 						// Try to guess the distrib used
@@ -4073,58 +4082,69 @@
 						if (!empty($dolibarr_distrib)) {
 							$distrib = $dolibarr_distrib;
 						}
-						?>
-							<script>
-							jQuery(document).ready(function (tmp) {
+				?>
+						<script>
+							jQuery(document).ready(function(tmp) {
 								console.log("Try Ping with hash_unique_id is dol_hash('dolibarr'+instance_unique_id, 'sha256')");
 								$.ajax({
-									  method: "POST",
-									  url: "<?php echo $url_for_ping ?>",
-									  timeout: 500,     // timeout milliseconds
-									  cache: false,
-									  data: {
-										  hash_algo: 'dol_hash-sha256',
-										  hash_unique_id: '<?php echo dol_escape_js($hash_unique_id); ?>',
-										  action: 'dolibarrping',
-										  version: '<?php echo (float) DOL_VERSION; ?>',
-										  entity: '<?php echo (int) $conf->entity; ?>',
-										  dbtype: '<?php echo dol_escape_js($db->type); ?>',
-										  country_code: '<?php echo $mysoc->country_code ? dol_escape_js($mysoc->country_code) : 'unknown'; ?>',
-										  php_version: '<?php echo dol_escape_js(phpversion()); ?>',
-										  os_version: '<?php echo dol_escape_js(version_os('smr')); ?>',
-										  db_version: '<?php echo dol_escape_js(version_db()); ?>',
-										  distrib: '<?php echo $distrib ? dol_escape_js($distrib) : 'unknown'; ?>',
-										  token: 'notrequired'
-									  },
-									  success: function (data, status, xhr) {   // success callback function (data contains body of response)
-											console.log("Ping ok");
-											$.ajax({
-												method: 'GET',
-												url: '<?php echo DOL_URL_ROOT.'/core/ajax/pingresult.php'; ?>',
-												timeout: 500,     // timeout milliseconds
-												cache: false,
-												data: { hash_algo: 'dol_hash-sha256', hash_unique_id: '<?php echo dol_escape_js($hash_unique_id); ?>', action: 'firstpingok', token: '<?php echo currentToken(); ?>' },	// for update
-											  });
-									  },
-									  error: function (data,status,xhr) {   // error callback function
-											console.log("Ping ko: " + data);
-											$.ajax({
-												  method: 'GET',
-												  url: '<?php echo DOL_URL_ROOT.'/core/ajax/pingresult.php'; ?>',
-												  timeout: 500,     // timeout milliseconds
-												  cache: false,
-												  data: { hash_algo: 'dol_hash-sha256', hash_unique_id: '<?php echo dol_escape_js($hash_unique_id); ?>', action: 'firstpingko', token: '<?php echo currentToken(); ?>' },
-												});
-									  }
+									method: "POST",
+									url: "<?php echo $url_for_ping ?>",
+									timeout: 500, // timeout milliseconds
+									cache: false,
+									data: {
+										hash_algo: 'dol_hash-sha256',
+										hash_unique_id: '<?php echo dol_escape_js($hash_unique_id); ?>',
+										action: 'dolibarrping',
+										version: '<?php echo (float) DOL_VERSION; ?>',
+										entity: '<?php echo (int) $conf->entity; ?>',
+										dbtype: '<?php echo dol_escape_js($db->type); ?>',
+										country_code: '<?php echo $mysoc->country_code ? dol_escape_js($mysoc->country_code) : 'unknown'; ?>',
+										php_version: '<?php echo dol_escape_js(phpversion()); ?>',
+										os_version: '<?php echo dol_escape_js(version_os('smr')); ?>',
+										db_version: '<?php echo dol_escape_js(version_db()); ?>',
+										distrib: '<?php echo $distrib ? dol_escape_js($distrib) : 'unknown'; ?>',
+										token: 'notrequired'
+									},
+									success: function(data, status,
+										xhr) { // success callback function (data contains body of response)
+										console.log("Ping ok");
+										$.ajax({
+											method: 'GET',
+											url: '<?php echo DOL_URL_ROOT . '/core/ajax/pingresult.php'; ?>',
+											timeout: 500, // timeout milliseconds
+											cache: false,
+											data: {
+												hash_algo: 'dol_hash-sha256',
+												hash_unique_id: '<?php echo dol_escape_js($hash_unique_id); ?>',
+												action: 'firstpingok',
+												token: '<?php echo currentToken(); ?>'
+											}, // for update
+										});
+									},
+									error: function(data, status, xhr) { // error callback function
+										console.log("Ping ko: " + data);
+										$.ajax({
+											method: 'GET',
+											url: '<?php echo DOL_URL_ROOT . '/core/ajax/pingresult.php'; ?>',
+											timeout: 500, // timeout milliseconds
+											cache: false,
+											data: {
+												hash_algo: 'dol_hash-sha256',
+												hash_unique_id: '<?php echo dol_escape_js($hash_unique_id); ?>',
+												action: 'firstpingko',
+												token: '<?php echo currentToken(); ?>'
+											},
+										});
+									}
 								});
 							});
-							</script>
-						<?php
+						</script>
+<?php
 					}
 				} else {
 					$now = dol_now();
 					print "\n<!-- NO JS CODE TO ENABLE the anonymous Ping. It was disabled -->\n";
-					include_once DOL_DOCUMENT_ROOT.'/core/lib/admin.lib.php';
+					include_once DOL_DOCUMENT_ROOT . '/core/lib/admin.lib.php';
 					dolibarr_set_const($db, 'MAIN_FIRST_PING_OK_DATE', dol_print_date($now, 'dayhourlog', 'gmt'), 'chaine', 0, '', $conf->entity);
 					dolibarr_set_const($db, 'MAIN_FIRST_PING_OK_ID', 'disabled', 'chaine', 0, '', $conf->entity);
 				}

########## product/stock/stockatdate.php
